// header file for Router.cpp

#ifndef deftestlink
 #include "Link.h"
#endif

#ifndef deftestip
 #include "IP.h"
#endif

#ifndef deftestlsup
 #include "Link_State_Update_Packet.h"
#endif

#ifndef deftestospfpq
 #include "OSPF_Packet_Queue.h"
#endif

#ifndef deftestospfpb
 #include "OSPF_Packet_Base.h"
#endif

#ifndef deftestrt
 #include "Routing_Table.h"
#endif

#ifndef deftestlsdb
 #include "LSDatabase.h"
#endif

#ifndef deftestspft
 #include "SP_Tree.h"
#endif

#define deftestrouter

class Router 
{
  // Constructors, Get, Set etc.
 public:
  Router();
  ~Router();
  int getNumber();
  IP& getID();
  int set(int num, char* ospfid);
  int setNumLinks(int count);
  int getPacketsToSendCount();
  OSPF_Packet* getPacketToSend();
  int packetReceived(OSPF_Packet* packet);

  //OSPF related methods
 public:
  int initialize();
  int flood();
 private:
  int calculateSPT();
  int calculateRoutingTable();
  
  //Operational Methods
 public:
  int addLink(Link* link);
  void display(FILE* outFile);
  void dispLSDB(FILE* outFile);
  void dispRTBL(FILE* outFile);

  // OSPF related Data Members  
 private:
  int number;
  IP id;
  int num_Links;
  Link **links;
  OSPF_Packet_Queue inQ;
  OSPF_Packet_Queue outQ;
  int routingTableSize;
  Routing_Table rt;
  LSDatabase lsdb;
  SP_Tree spt;
};
