//the header file for Simulator

#ifndef	deftestrouter
 #include "Router.h"
#endif

#ifndef	deftestnetwork
 #include "Network.h"
#endif

#define	deftestsim

class Simulator 
{
  //Constructor, Get, Set etc.
 public:
  Simulator();
  ~Simulator();
 private:
  int set_Routers (int index, int number, char* id);
  int set_Links (int index, int id, char typ, int id1, int id2, short cost);
  int set_Networks (int index, int num, char* id, char* mask);
  int getRouterIndex(int routerNumber);
  int getNetworkIndex(int networkNumber);
  int getLinkIndex(int linkNumber);
  int existRouter(int num);
  int existRouter(char* ospfid);
  int existLink(int id);
  int existNetwork(int num);
  int existNetwork(char* ospfid);
  
 public:
  void dispRouter(char* index);
  void dispTopology();
  void dispLSDB(char* routerIndex);
  void dispRTBL(char* routerIndex);

  //Operational Methods
 public:
  int read_Topology ();
  int unload_Topology();
  
  //OSPF related methods
 public:
  int verify();
  int initialize();
  int simulate();
  int out();

 private:
  int addRouterLinks();
  int addLinkEndIPs();
  int countRouterLinks();

 private: // OSPF related Data Members
  int num_Routers;
  int num_Links;
  int num_Networks;
  Router *routers;
  Link *links;
  Network *networks;
  
 public://operational Data Members
  char topologyFile[256];
};

